section
  name Legacy API

  section(anchor="EACS_old")
    name EACS [deprecated]

    t
      | The #[em EACS] service is used as a scheduler to synchronize all
      | components together.

    t
      | It #[bcp14 MUST] be the main entry point for the #[xref(target='GUI') GUI].

    section
      name Configuration

      t
        | The #[em EACS] service #[bcp14 SHOULD] be configured to define
        | thresholds and timeout values.
      figure
        name EACS Configuration #[xref(target="RELAX_NG") relax-ng compact schema].
        sourcecode(type='rnc' src='ntof-software-architecture/files/old/EACS_Configuration.rnc')

      t The configuration file default location is
        | #[tt "/root/config/eacs.xml"].

      t
        | The list of available hardware and services is retrieved from the
        | #[xref(target='GLOBAL_CONFIG') global configuration] file.

    section
      name DIM API

      t The EACS service implements the following DIM services
      table(align='center')
        name DIM services
        thead
          tr #[th Service] #[th Description]
        tbody
          tr
            td EACS/State
            td #[xref(target="EACS_old_State") EACS service state]
          tr
            td EACS/RunInfo
            td #[xref(target="EACS_old_RunInfo") EACS Run Information state]
          tr
            td EACS/FilesInfo
            td #[xref(target="EACS_old_RunInfo") EACS Files and Events information]
          tr
            td EACS/EVEH
            td #[xref(target="EACS_old_EVEH") Last received Event information]
          tr
            td EACS/MODH
            td #[xref(target="EACS_old_MODH") Acquisition cards configuration]
          tr
            td EACS/RCTR
            td #[xref(target="EACS_old_RCTR") Run configuration]
          tr
            td EACS/DAQs
            td #[xref(target="EACS_old_DAQs") Active DAQs list]

          tr
            td EACS/Command
            td #[xref(target="EACS_old_Command") EACS Control]

      section(anchor="EACS_old_State")
        name EACS/State service

        t
          | This service is a State Service as described in
          | #[xref(target="dim-xml-extension-01") DIM XML Extension],
          | it reports the current EACS state.

        figure
          name EACS state diagram
          artwork(align='center' type='binary-art' src='ntof-software-architecture/files/old/EACS-ServiceStateMachine.png')

      section(anchor="EACS_old_RunInfo")
        name EACS/RunInfo service

        t This service is a DataSet Service as described in
          | #[xref(target="dim-xml-extension-01") DIM XML Extension],
          | it reports information about the ongoing acquisition.

        table
          name EACS/RunInfo service data
          thead
            tr #[th name] #[th index] #[th description]
          tbody
            tr #[td run number] #[td 1] #[td run number]
            tr #[td event number] #[td 2] #[td event number]
            tr #[td number of protons] #[td 3] #[td Number of protons (for current event)]
            tr #[td number of events valid] #[td 4] #[td Number of events validated]
            tr #[td number of daqs in the run] #[td 6] #[td Number of active DAQs for the acquisition]

      section(anchor="EACS_old_FilesInfo")
        name EACS/FilesInfo service

        t
          | This service provides some information about the last events that
          | happened and their file-related status.

        t
          | This service reports information about the #[tt 10] last events
          | that have been reported.

        figure
          name EACS/FilesInfo service #[xref(target="RELAX_NG") relax-ng compact schema].
          sourcecode(type='rnc' src='ntof-software-architecture/files/old/EACS_FilesInfo.rnc')

      section(anchor="EACS_old_EVEH")
        name EACS/EVEH service

        t This service provides information about the last event retrieved.

        figure
          name EACS/EVEH service #[xref(target="RELAX_NG") relax-ng compact schema].
          sourcecode(type='rnc' src='ntof-software-architecture/files/old/EACS_EVEH.rnc')

      section(anchor="EACS_old_MODH")
        name EACS/MODH service

        t This service is a Command Service as described in #[xref(target="dim-xml-extension-01") DIM XML Extension].

        t
          | It is used to configure the DAQs before starting an acquisition,
          | commands are accepted by this service on in #[tt WAITING_FOR_HEADERS] or
          | #[tt WAITING_FOR_MODH] #[xref(target='EACS_old_State') EACS State].

        figure
          name EACS/EVEH service #[xref(target="RELAX_NG") relax-ng compact schema].
          sourcecode(type='rnc' src='ntof-software-architecture/files/old/EACS_MODH_cmd.rnc')

      section(anchor="EACS_old_RCTR")
        name EACS/RCTR service

        t This service is a Command Service as described in #[xref(target="dim-xml-extension-01") DIM XML Extension].

        t
          | It is used to configure the DAQs before starting an acquisition,
          | commands are accepted by this service on in #[tt WAITING_FOR_HEADERS] or
          | #[tt WAITING_FOR_RCTR] #[xref(target='EACS_old_State') EACS State].

        figure
          name EACS/RCTR service #[xref(target="RELAX_NG") relax-ng compact schema].
          sourcecode(type='rnc' src='ntof-software-architecture/files/old/EACS_RCTR_cmd.rnc')

      section(anchor="EACS_old_DAQs")
        name EACS/DAQs service

        t This service provides information about the currently active DAQs.

        figure
          name EACS/DAQs service #[xref(target="RELAX_NG") relax-ng compact schema].
          sourcecode(type='rnc' src='ntof-software-architecture/files/old/EACS_DAQs.rnc')

      section(anchor="EACS_old_Command")
        name EACS/Command service

        t This service is a Command Service as described in #[xref(target="dim-xml-extension-01") DIM XML Extension].

        t It is used to send global Commands to the EACS.

        t Commands are accepted only if the EACS is not in error state.

        figure
          name EACS/Command service #[xref(target="RELAX_NG") relax-ng compact schema].
          sourcecode(type='rnc' src='ntof-software-architecture/files/old/EACS_Command_cmd.rnc')

  section
    name Castor Merger [deprecated]

    t
      | The #[em Castor Merger] service is used to merge acquisition files in
      | a single stream of files, that will be split according to the number
      | of events or size they reach.

    t
      | Once complete files are then copied and pushed on #[xref(target='CASTOR') CASTOR]
      | tape storage.

    section
      name File state

      t
        | A castor file can be in the following states:
      ul
        li #[strong INCOMPLETE] file is not yet finished, some data can be appended.
        li #[strong WAITING] file is waiting to be transferred on Castor.
        li #[strong TRANSFERRING] the file is being transferred to Castor.
        li #[strong COPIED] the file has been copied to Castor, but not yet migrated on tape.
        li #[strong MIGRATED] the file has been migrated on tape.
        li #[strong IGNORED] the file should not be copied to Castor.
        li #[strong FAILED] the Castor transfer failed somehow, further attempts may be achieved.

    section
      name File conflicts handling

      t
        | The CastorMerger supports two different file conflict handling
        | strategies:
      ul
        li
          | #[strong RENAME]: old file is renamed with #[tt ".old"] suffix,
          | or #[tt= '".old[0-9]+"'] incrementing a counter until it finds a
          | free slot.
        li #[strong DELETE]: old file is simply deleted.

      t #[strong Note:] empty files are always deleted.

    section
      name Configuration

      t
        | The #[em CastorMerger] service #[bcp14 MAY] be configured:
      figure
        name CastorMerger configuration
        sourcecode(type='rnc' src='ntof-software-architecture/files/CastorMerger_Configuration.rnc')

      t
        | The configuration file default location is
        | #[tt "/root/config/castor.xml"].

    section
      name DIM API

      t The CastorMerger service implements the following DIM services
      table(align='center')
        name DIM services
        thead
          tr #[th Service] #[th Description]
        tbody
          tr
            td CASTOR/State
            td #[xref(target='OLD_CASTOR_MERGER_State') Castor Merger service state]
          tr
            td CASTOR/Info
            td #[xref(target='OLD_CASTOR_MERGER_Info') Castor Merger info service]
          tr
            td CASTOR/Cmd
            td #[xref(target='OLD_CASTOR_MERGER_Cmd') Castor Merger command service]

      section(anchor="OLD_CASTOR_MERGER_State")
        name CASTOR/State service

        t
          | This service is a State Service as described in
          | #[xref(target="dim-xml-extension-01") DIM XML Extension],
          | it reports the current CastorMerger state.

        t
          | This state machine is really basic and is mostly used to report
          | errors and warnings, it has only one state (in addition to the
          | builtin states): #[tt OK(0)]
        t
          | A non exhaustive list of possible errors and warnings:
        table(align="center")
          name CASTOR errors
          thead
            tr #[th Error] #[th Code] #[th Type] #[th Description]
          tbody
            tr #[td= "<filename>"] #[td incremental] #[td warning] #[td some warning about a specific file]
            tr #[td= "<filename>"] #[td incremental] #[td error] #[td some error about a specific file]
            tr #[td CmdError] #[td 1] #[td error] #[td received command error]
            tr #[td runCompletionChecker] #[td incremental] #[td error] #[td something went wrong in the runCompletionChecker thread]
            tr #[td Deleter] #[td incremental] #[td error] #[td something went wrong in the FileDeleter thread]

        t
          | The maximum number of active warnings and errors is limited
          | dropping incoming errors and warnings when there's already too
          | much (default limit: #[tt 20]).

      section(anchor="OLD_CASTOR_MERGER_Info")
        name CASTOR/Info service

        t
          | This service provides information about the latest files that
          | are being handled by the Castor Merger.

        t
          | It will only keep up to a certain number (default: #[tt 10]) of files
          | that are in #[tt COPIED], #[tt MIGRATED] or #[tt IGNORED] state.

        figure
          name CASTOR/Info Service #[xref(target="RELAX_NG") relax-ng compact schema].
          sourcecode(type='rnc' src='ntof-software-architecture/files/CastorMerger_Info.rnc')

      section(anchor="OLD_CASTOR_MERGER_Cmd")
        name CASTOR/Cmd service

        t This service is a Command Service as described in #[xref(target="dim-xml-extension-01") DIM XML Extension].

        figure
          name CASTOR/Cmd Service #[xref(target="RELAX_NG") relax-ng compact schema].
          sourcecode(type='rnc' src='ntof-software-architecture/files/CastorMerger_Cmd_cmd.rnc')
